=== debian/changelog ===
neovim (0.9.5-7) unstable; urgency=medium

  [ Colin Watson ]
  * fix(fileio): fix off-by-one in rename_with_tmp
  * Revert "Explicitly downgrade _FORTIFY_SOURCE to 1"

  [ James McCoy ]
  * Use cmake+ninja buildsystem instead of overriding dh_auto_configure
  * Remove pkg-config Build-Depends

 -- James McCoy <jamessan@debian.org>  Sun, 24 Mar 2024 09:13:28 -0400

neovim (0.9.5-6) unstable; urgency=medium

  * Revert "Change packaging branch to debian/experimental"
  * Revert "CI: Set release to experimental"
  * Skip "memory usage releases memory when closing windows" for all platforms

 -- James McCoy <jamessan@debian.org>  Mon, 04 Mar 2024 09:22:50 -0500

neovim (0.9.5-5) unstable; urgency=medium

  * Upload to unstable
  * Build with LuaJIT on arm64 (Closes: #1061154)

 -- James McCoy <jamessan@debian.org>  Mon, 04 Mar 2024 06:33:29 -0500

neovim (0.9.5-4) experimental; urgency=medium

  * Add lua-coxpcall as a test Build-Depends, since it's needed for non-LuaJIT
    platforms

 -- James McCoy <jamessan@debian.org>  Tue, 09 Jan 2024 16:58:30 -0500

neovim (0.9.5-3) experimental; urgency=medium

  * Remove lua-nvim Build-Depends
  * Provide a custom $XDG_RUNTIME_DIR when running tests.  $XDG_RUNTIME_DIR is
    leaking into the sbuild environment on the buildds and causing the tests
    to hang because the test can't access the external directory.
    Thanks to Vincent Blut for diagnosing the problem. (Closes: #1060340)
  * Revert "Skip wundo_spec.lua tests since they hang on the buildds"

 -- James McCoy <jamessan@debian.org>  Tue, 09 Jan 2024 15:42:25 -0500

neovim (0.9.5-2) experimental; urgency=medium

  * Backport upstream patch
    + fix(tui): use buflen to calculate remaining buffer size
  * Skip wundo_spec.lua tests since they hang on the buildds

 -- James McCoy <jamessan@debian.org>  Sun, 07 Jan 2024 15:34:34 -0500

neovim (0.9.5-1) experimental; urgency=medium

  * New upstream release
    + Remove backported patches
  * Skip functionaltest which hangs in Salsa CI/buildd environments
  * Backport upstream patches
    + fix(test): call separate_arguments() correctly to honor $BUSTED_ARGS
    + fix(test/tui_spec): pass the expected NULL-sentinel to execl()
  * Skip "parser API supports caching queries" test, since it is too variable

 -- James McCoy <jamessan@debian.org>  Sat, 06 Jan 2024 10:06:26 -0500

neovim (0.9.4-2) experimental; urgency=medium

  * Backport fixes for big-endian systems

 -- James McCoy <jamessan@debian.org>  Fri, 22 Dec 2023 09:30:56 -0500

neovim (0.9.4-1) experimental; urgency=medium

  * New upstream release (Closes: #1021339)
  * Remove backported patches from 0.7 release
  * Revert "Disable strict aliasing to fix gcc-12 FTBFS", fixed upstream
  * Backport patches to fix test failures
  * Backport patch to remove incompatible tree-sitter query for c parser
  * debian/control:
    + Remove gperf Build-Depends, replaced by upstream's "hashy" script
    + Bump minimum versions of libvterm/libtermkey to 0.3/0.22
  * debian/rules:
    + Remove override of BUSTED_OUTPUT_TYPE
    + Fix spelling of "noopt" when checking DEB_BUILD_OPTIONS
    + Stop exporting $USERNAME and $HOSTNAME during the build, no longer used
  * Change packaging branch to debian/experimental
  * Enable tree-sitter support for C, lua, vim, vimdoc, and tree-sitter
    queries

 -- James McCoy <jamessan@debian.org>  Mon, 18 Dec 2023 08:13:20 -0500

neovim (0.7.2-8) unstable; urgency=medium

  * Backport upstream patch, "fix(unittests): ignore __s128 and __u128 types
    in ffi", to fix FTBFS with recent Linux headers. (Closes: #1052945)

 -- James McCoy <jamessan@debian.org>  Fri, 29 Sep 2023 09:21:25 -0400
